diff mbox

[3/9] perf build: Test correct path of perf in build-test

Message ID 1452687442-6186-4-git-send-email-wangnan0@huawei.com
State Superseded
Headers show

Commit Message

Wang Nan Jan. 13, 2016, 12:17 p.m. UTC
If an 'O' is passed to 'make build-test', many 'test -x' and 'test -f'
will fail because perf resides in a different directory. Fix this by
computing PERF_OUT according to 'O' and test correct output files.
For make_kernelsrc and make_kernelsrc_tools, set KBUILD_OUTPUT_DIR
instead because the path is different from others ($(O)/perf vs
 $(O)/tools/perf).

Signed-off-by: Wang Nan <wangnan0@huawei.com>

Cc: Arnaldo Carvalho de Melo <acme@redhat.com>
Cc: Jiri Olsa <jolsa@kernel.org>
Cc: Namhyung Kim <namhyung@kernel.org>
---
 tools/perf/tests/make | 23 +++++++++++++++--------
 1 file changed, 15 insertions(+), 8 deletions(-)

-- 
1.8.3.4

Comments

Wang Nan Jan. 14, 2016, 9:59 a.m. UTC | #1
On 2016/1/14 17:57, Jiri Olsa wrote:
> On Wed, Jan 13, 2016 at 12:17:16PM +0000, Wang Nan wrote:

>

> SNIP

>

>> +test_make_python_perf_so := test -f $(PERF_OUT)/python/perf.so

>>   

>> -test_make_perf_o           := test -f $(PERF)/perf.o

>> -test_make_util_map_o       := test -f $(PERF)/util/map.o

>> -test_make_util_pmu_bison_o := test -f $(PERF)/util/pmu-bison.o

>> +test_make_perf_o           := test -f $(PERF_OUT)/perf.o

>> +test_make_util_map_o       := test -f $(PERF_OUT)/util/map.o

>> +test_make_util_pmu_bison_o := test -f $(PERF_OUT)/util/pmu-bison.o

>>   

>>   define test_dest_files

>>     for file in $(1); do				\

>> @@ -244,7 +246,7 @@ test_make_perf_o_O            := test -f $$TMP_O/perf.o

>>   test_make_util_map_o_O        := test -f $$TMP_O/util/map.o

>>   test_make_util_pmu_bison_o_O := test -f $$TMP_O/util/pmu-bison.o

>>   

>> -test_default = test -x $(PERF)/perf

>> +test_default = test -x $(PERF_OUT)/perf

>>   test = $(if $(test_$1),$(test_$1),$(test_default))

>>   

>>   test_default_O = test -x $$TMP_O/perf

>> @@ -264,7 +266,7 @@ endif

>>   

>>   MAKEFLAGS := --no-print-directory

>>   

>> -clean := @(cd $(PERF); make -s -f $(MK) clean >/dev/null)

>> +clean := @(cd $(PERF); make -s -f $(MK) O=$(PERF_OUT) clean >/dev/null; make -s -f $(MK) clean >/dev/null)

> what's the second make clean for?


I want to ensure the source directory is also clean.

Looks like I forget 'O' would be passed to the second make also...

> thanks,

> jirka
Wang Nan Jan. 14, 2016, 10:14 a.m. UTC | #2
On 2016/1/14 18:04, Jiri Olsa wrote:
> On Wed, Jan 13, 2016 at 12:17:16PM +0000, Wang Nan wrote:

>

> SNIP

>

>>   	( eval $$cmd ) >> $@ 2>&1 && \

>>   	rm -f $@

>>   

>> +KBUILD_OUTPUT_DIR := ../..

>> +ifneq ($(O),)

>> +  KBUILD_OUTPUT_DIR := $(O)

>> +endif

>> +

>>   make_kernelsrc:

>>   	@echo "- make -C <kernelsrc> $(PARALLEL_OPT) tools/perf"

>>   	$(call clean); \

>>   	(make -C ../.. $(PARALLEL_OPT) tools/perf) > $@ 2>&1 && \

>> -	test -x perf && rm -f $@ || (cat $@ ; false)

>> +	test -x $(KBUILD_OUTPUT_DIR)/tools/perf && rm -f $@ || (cat $@ ; false)

> do you miss one extra /perf in here? like it should be

>

>     test -x $(KBUILD_OUTPUT_DIR)/tools/perf/perf


Right. Will fix.

Thank you.
diff mbox

Patch

diff --git a/tools/perf/tests/make b/tools/perf/tests/make
index 14d7b8d..1e59ce8 100644
--- a/tools/perf/tests/make
+++ b/tools/perf/tests/make
@@ -13,10 +13,12 @@  else
 endif
 else
 PERF := .
+PERF_OUT := $(PERF)
 O_OPT :=
 
 ifneq ($(O),)
   FULL_O := $(shell readlink -f $(O) || echo $(O))
+  PERF_OUT := $(FULL_O)
   ifeq ($(SET_O),1)
     O_OPT := 'O=$(FULL_O)'
   endif
@@ -173,11 +175,11 @@  test_make_doc    := $(test_ok)
 test_make_help_O := $(test_ok)
 test_make_doc_O  := $(test_ok)
 
-test_make_python_perf_so := test -f $(PERF)/python/perf.so
+test_make_python_perf_so := test -f $(PERF_OUT)/python/perf.so
 
-test_make_perf_o           := test -f $(PERF)/perf.o
-test_make_util_map_o       := test -f $(PERF)/util/map.o
-test_make_util_pmu_bison_o := test -f $(PERF)/util/pmu-bison.o
+test_make_perf_o           := test -f $(PERF_OUT)/perf.o
+test_make_util_map_o       := test -f $(PERF_OUT)/util/map.o
+test_make_util_pmu_bison_o := test -f $(PERF_OUT)/util/pmu-bison.o
 
 define test_dest_files
   for file in $(1); do				\
@@ -244,7 +246,7 @@  test_make_perf_o_O            := test -f $$TMP_O/perf.o
 test_make_util_map_o_O        := test -f $$TMP_O/util/map.o
 test_make_util_pmu_bison_o_O := test -f $$TMP_O/util/pmu-bison.o
 
-test_default = test -x $(PERF)/perf
+test_default = test -x $(PERF_OUT)/perf
 test = $(if $(test_$1),$(test_$1),$(test_default))
 
 test_default_O = test -x $$TMP_O/perf
@@ -264,7 +266,7 @@  endif
 
 MAKEFLAGS := --no-print-directory
 
-clean := @(cd $(PERF); make -s -f $(MK) clean >/dev/null)
+clean := @(cd $(PERF); make -s -f $(MK) O=$(PERF_OUT) clean >/dev/null; make -s -f $(MK) clean >/dev/null)
 
 $(run):
 	$(call clean)
@@ -293,17 +295,22 @@  tarpkg:
 	( eval $$cmd ) >> $@ 2>&1 && \
 	rm -f $@
 
+KBUILD_OUTPUT_DIR := ../..
+ifneq ($(O),)
+  KBUILD_OUTPUT_DIR := $(O)
+endif
+
 make_kernelsrc:
 	@echo "- make -C <kernelsrc> $(PARALLEL_OPT) tools/perf"
 	$(call clean); \
 	(make -C ../.. $(PARALLEL_OPT) tools/perf) > $@ 2>&1 && \
-	test -x perf && rm -f $@ || (cat $@ ; false)
+	test -x $(KBUILD_OUTPUT_DIR)/tools/perf && rm -f $@ || (cat $@ ; false)
 
 make_kernelsrc_tools:
 	@echo "- make -C <kernelsrc>/tools $(PARALLEL_OPT) perf"
 	$(call clean); \
 	(make -C ../../tools $(PARALLEL_OPT) perf) > $@ 2>&1 && \
-	test -x perf && rm -f $@ || (cat $@ ; false)
+	test -x $(KBUILD_OUTPUT_DIR)/tools/perf && rm -f $@ || (cat $@ ; false)
 
 all: $(run) $(run_O) tarpkg make_kernelsrc make_kernelsrc_tools
 	@echo OK